import { IContainer } from '@ts-ioc/core';
import { AppConfigure, IApplicationBuilder, IConfigureLoader } from '@ts-ioc/bootstrap';
export declare class ConfigureFileLoader implements IConfigureLoader<AppConfigure> {
    private baseURL;
    private container;
    constructor(baseURL: string, container: IContainer);
    load(uri?: string): Promise<AppConfigure>;
    static getClassAnnations(): any;
}
/**
 * server app.
 *
 * @export
 * @template T
 * @param {string} [baseURL]
 * @returns {IApplicationBuilderServer<T>}
 */
export declare function serverApp<T>(baseURL?: string): IApplicationBuilder<T>;
/**
 * server boot module
 *
 * @export
 * @class ServerBootstrapModule
 */
export declare class ServerBootstrapModule {
    static getClassAnnations(): any;
}
